//	Mini-LED-Cube 1.0 - Alternativ
//
//	Buggy!
//
//	Copyright (C) 2009 Paul Wilhelm <paul@mosfetkiller.de>
//	http://mosfetkiller.de/?s=miniledcube

//	Includes
#define F_CPU 8000000UL
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/pgmspace.h>

//	Definitionen
#define	set_bit(var, bit)	((var) |= (1 << (bit)))
#define	clear_bit(var, bit)	((var) &= (unsigned)~(1 << (bit)))

#define FALSE	0
#define TRUE	1

#define PIXEL_TON	30
#define PIXEL_TOFF	10

//	Cube-Array
unsigned char cube[3][3][3];
unsigned char buffer[3][3][3];	//	Framebuffer

//	Frame-Zähler
volatile unsigned char frame_counter = 0;
volatile unsigned char frame_max = 4;

//	Prototypen
void init();


//	Pixelmakros
#define PIX_SET(x,y,z)		(0b01000000 | ((z * 3 + x) + y * 9))
#define PIX_CLEAR(x,y,z)	(0b00000000 | ((z * 3 + x) + y * 9))

//	Opcodes
#define OP_CLEAR	0b10000000
#define OP_SET		0b10010000
#define OP_			0b10100000	//	No operation (reserved)
#define OP_LOAD		0b10110000
#define OP_INC		0b11000000
#define OP_DEC		0b11010000
#define OP_SKIZ		0b11100000
#define OP_NEXT		0b11110000

//	Variablen
#define VAR_FPS	0
#define VAR_1	1
#define VAR_2	2
#define VAR_3	3
#define VAR_4	4
#define VAR_5	5
#define VAR_6	6
#define VAR_7	7

//	Für CLEAR und SET
#define OP_CLEAR_ALL	0
#define OP_SET_ALL		0

//	Für NEXT
#define JUMP_FORWARD	1
#define JUMP_BACKWARD	2


//	Programmcode
const prog_char program_1[] =
{
	OP_LOAD + VAR_FPS, 0,		//	VAR_FPS = 0 setzen - d.h., der Frame erzeugt keine Wartezeit
	OP_LOAD + VAR_1, 4,			//	Zähler VAR_1 = 4 setzen
	OP_NEXT,					//	Nächster Frame

	OP_LOAD + VAR_FPS, 50,		//	VAR_FPS = 50 setzen
	OP_SET,						//	Cube füllen
	OP_NEXT,

	OP_CLEAR,					//	Cube leeren
	OP_DEC + VAR_1,				//	Zähler VAR_1--
	OP_SKIZ + VAR_1,			//	Nächste Instruction überspringen, wenn Zähler VAR_1 == 0
	OP_NEXT + JUMP_BACKWARD, 1,	//	Ansonsten einen Frame zurückspringen

	PIX_SET(0,0,0),				//	Pixel setzen
	OP_NEXT + JUMP_FORWARD, 2,	//	Nächsten beiden Frames überspringen

	PIX_CLEAR(0,0,0),			//	Pixel löschen
	OP_NEXT,

	PIX_SET(2,2,2),				//	Pixel setzen
	OP_NEXT,

	PIX_SET(1,1,1),				//	Pixel setzen
	OP_NEXT,

	PIX_CLEAR(1,1,1),			//	Pixel löschen
	OP_NEXT,

	OP_LOAD + VAR_FPS, 20,		//	VAR_FPS = 0 setzen - d.h., der Frame erzeugt keine Wartezeit
	OP_NEXT + JUMP_BACKWARD, 2	//	Die letzten beiden Frames in einer Endlosschleife ausführen
/*
	OP_LOAD + VAR_FPS, 10,

	OP_CLEAR, OP_SET + 12, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,	//	Vor- und zurück tanzen
	OP_CLEAR, OP_SET + 12, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,
	OP_CLEAR, OP_SET + 12, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_CLEAR, OP_SET + 12, OP_NEXT, OP_CLEAR, OP_SET + 15,

	OP_LOAD + VAR_FPS, 5, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,	//	Umdrehung
	OP_LOAD + VAR_FPS, 5, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_LOAD + VAR_FPS, 6, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,
	OP_LOAD + VAR_FPS, 6, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_LOAD + VAR_FPS, 7, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,
	OP_LOAD + VAR_FPS, 7, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_LOAD + VAR_FPS, 8, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,
	OP_LOAD + VAR_FPS, 8, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_LOAD + VAR_FPS, 9, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,
	OP_LOAD + VAR_FPS, 9, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_LOAD + VAR_FPS, 10, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 14, OP_NEXT,
	OP_LOAD + VAR_FPS, 10, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 15, OP_NEXT,
	OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 12, OP_NEXT,	//	Umfallen
	OP_CLEAR, OP_SET + 4, OP_NEXT, OP_CLEAR, OP_SET + 5, OP_NEXT, OP_CLEAR, OP_SET + 6, OP_NEXT,	//	Ebenen
	OP_CLEAR, OP_SET + 1, OP_NEXT, OP_CLEAR, OP_SET + 2, OP_NEXT, OP_CLEAR, OP_SET + 3, OP_NEXT,
	OP_CLEAR, OP_SET + 7, OP_NEXT, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 9, OP_NEXT,

	OP_LOAD + 0, 10,	//	Außen langlaufen

	OP_CLEAR,
	PIX_SET(0,0,0), PIX_SET(1,0,0), PIX_SET(0,1,0), PIX_SET(1,1,0), PIX_SET(0,2,0), PIX_SET(1,2,0), OP_NEXT,
	PIX_CLEAR(0,0,0), PIX_SET(2,0,0), PIX_CLEAR(0,1,0), PIX_SET(2,1,0), PIX_CLEAR(0,2,0), PIX_SET(2,2,0), OP_NEXT,
	PIX_CLEAR(1,0,0), PIX_SET(2,0,1), PIX_CLEAR(1,1,0), PIX_SET(2,1,1), PIX_CLEAR(1,2,0), PIX_SET(2,2,1), OP_NEXT,
	PIX_CLEAR(2,0,0), PIX_SET(2,0,2), PIX_CLEAR(2,1,0), PIX_SET(2,1,2), PIX_CLEAR(2,2,0), PIX_SET(2,2,2), OP_NEXT,
	PIX_CLEAR(2,0,1), PIX_SET(1,0,2), PIX_CLEAR(2,1,1), PIX_SET(1,1,2), PIX_CLEAR(2,2,1), PIX_SET(1,2,2), OP_NEXT,
	PIX_CLEAR(2,0,2), PIX_SET(0,0,2), PIX_CLEAR(2,1,2), PIX_SET(0,1,2), PIX_CLEAR(2,2,2), PIX_SET(0,2,2), OP_NEXT,
	PIX_CLEAR(1,0,2), PIX_SET(0,0,1), PIX_CLEAR(1,1,2), PIX_SET(0,1,1), PIX_CLEAR(1,2,2), PIX_SET(0,2,1), OP_NEXT,
	PIX_CLEAR(0,0,2), PIX_SET(0,0,0), PIX_CLEAR(0,1,2), PIX_SET(0,1,0), PIX_CLEAR(0,2,2), PIX_SET(0,2,0), OP_NEXT,
	PIX_CLEAR(0,0,1), PIX_CLEAR(0,1,1), PIX_CLEAR(0,2,1),

	OP_SET + 7, OP_NEXT, OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 9, OP_NEXT,
	OP_CLEAR, OP_SET + 8, OP_NEXT, OP_CLEAR, OP_SET + 7, OP_NEXT,*/
};


//	Programmzähler
unsigned int program_counter = 0;
const prog_char *program_pointer = program_1;
unsigned int program_length = sizeof(program_1);
unsigned char program_var[8];


//	Main
int main(void)
{

	//	Initialisieren
	init();

	//	Hauptschleife
	while (1)
	{

		unsigned char instruction = pgm_read_byte(&(program_pointer[program_counter]));

		if ((instruction & 0b10000000) == 0)
		//	Pixel
		{
			unsigned char coord = instruction & 0b00111111;	//	Uns interessieren nur die 6 untersten Bits

			unsigned char y = coord / 9;
			unsigned char x = (coord - y * 9) % 3;
			unsigned char z = (coord - y * 9) / 3;
			buffer[x][y][z] = (instruction & 0b01000000) / 0b01000000;
		}
		else
		//	Opcode
		{
			unsigned char operation = instruction & 0b11110000;	//	Uns interessieren nur die 4 obersten Bits

			if (operation == OP_CLEAR || operation == OP_SET)
			{
				unsigned char frame = instruction & 0b00001111;

				//	Folgende Werte entsprechen OP_SET_ALL
				unsigned char x_min = 0, x_max = 3, y_min = 0, y_max = 3, z_min = 0, z_max = 3;

				//	Folgendes kann noch optimiert werden.

				//	Y-Z-Ebene (links, mitte, rechts)
				if (frame == 1) { x_min = 0; x_max = 1; }
				if (frame == 2) { x_min = 1; x_max = 2; }
				if (frame == 3) { x_min = 2; x_max = 3; }

				//	X-Z-Ebene (unten, mitte, oben)
				if (frame == 4) { y_min = 0; y_max = 1; }
				if (frame == 5) { y_min = 1; y_max = 2; }
				if (frame == 6) { y_min = 2; y_max = 3; }

				//	X-Y-Ebene (hinten, mitte, vorne)
				if (frame == 7) { z_min = 0; z_max = 1; }
				if (frame == 8) { z_min = 1; z_max = 2; }
				if (frame == 9) { z_min = 2; z_max = 3; }

				if (frame < 10)
				{
					for (unsigned char z = z_min; z < z_max; z++)
						for (unsigned char y = y_min; y < y_max; y++)
							for (unsigned char x = x_min; x < x_max; x++)
								if (operation == OP_SET) buffer[x][y][z] = 1; else buffer[x][y][z] = 0;
				} else
				{
					for (unsigned char a = 0; a < 3; a++)
						for (unsigned char b = 0; b < 3; b++)
						{
							unsigned char x = 0, y = 0, z = 0;

							if (frame == 10) { x = a; y = b; z = b; }			//	Unten hinten nach oben vorne
							if (frame == 11) { x = a; y = a; z = b; }			//	Unten links nach oben rechts
							if (frame == 12) { x = a; y = b; z = 2 - b; }		//	Unten vorne nach oben hinten
							if (frame == 13) { x = a; y = 2 - a; z = b; }		//	Oben links nach unten rechts
							if (frame == 14) { x = b; y = a; z = b; }			//	Hinten links nach vorne rechts
							if (frame == 15) { x = a; y = 2 - b; z = 2 - a; }	//	Vorne links nach hinten rechts

							if (operation == OP_SET) buffer[x][y][z] = 1; else buffer[x][y][z] = 0;
						}
				}
			} else

			if (operation == OP_)
			{
			} else

			if (operation == OP_LOAD)
			{
				unsigned char var_num = instruction & 0b00001111;

				if (program_counter + 1 < program_length) program_counter++; //	else: Fehler
				unsigned char byte = pgm_read_byte(&(program_pointer[program_counter]));

				program_var[var_num] = byte;
			} else

			if (operation == OP_INC)
			{
				unsigned char var_num = instruction & 0b00001111;

				if (program_var[var_num] < 255) program_var[var_num]++;
			} else

			if (operation == OP_DEC)
			{
				unsigned char var_num = instruction & 0b00001111;

				if (program_var[var_num] > 0) program_var[var_num]--;
			} else

			if (operation == OP_SKIZ)
			{
				unsigned char var_num = instruction & 0b00001111;

				if (program_var[var_num] == 0)
				{
					if (program_counter + 1 < program_length)
					{
						program_counter++;

						//	LOAD- und NEXT-Instructions sind zwei Bytes lang,
						//	daher müssen dort auch zwei Bytes übersprungen werden
						unsigned char this_op = pgm_read_byte(&(program_pointer[program_counter]));
						if (this_op == OP_LOAD || this_op == OP_NEXT) program_counter++;
					}
					//	else: Fehler
				}
			} else

			if (operation == OP_NEXT)
			{
				unsigned char jump = instruction & 0b00001111;

				//	VAR_FPS = 0: Frame nicht zeichnen, keine Wartezeit
				if (program_var[VAR_FPS] > 0)
				{
					//	Temporäres Array ins "echte" Array kopieren
					for (unsigned char z = 0; z < 3; z++)
						for (unsigned char y = 0; y < 3; y++)
							for (unsigned char x = 0; x < 3; x++)
								cube[x][y][z] = buffer[x][y][z];

					for (unsigned char i = 0; i < program_var[VAR_FPS]; i++)
					{
						_delay_ms(5);
					}
				}

				unsigned char frame_count = pgm_read_byte(&(program_pointer[program_counter + 1]));

				if (jump == JUMP_FORWARD && frame_count > 0)	//	Wenn frame_count == 0, nichts tun
				{
					//	Springe frame_count frames vorwärts

					program_counter += 2;

					unsigned char search = TRUE;
					while (search)
					{
						unsigned char op = pgm_read_byte(&(program_pointer[program_counter]));

						//	Bei einer Load-Instruction das zweite Byte überspringen
						if ((op & OP_LOAD) == OP_LOAD)
						{
							program_counter++;
						}
						else if ((op & OP_NEXT) == OP_NEXT)
						{
							if (frame_count > 0)
							{
								//	NEXT entdeckt, aber noch nicht am Ziel
								frame_count--;
							}

						}

						//	Nächste Instruction
						if (program_counter < program_length)
						{
							program_counter++;
						}
						else
						{
							//	Untere Programmgrenze erreicht
							search = FALSE;
						}

						if (search)
						{
							if (frame_count == 0)
							{
								//	Ziel erreicht
								search = FALSE;

								//	Bei zwei Byte langer NEXT-Instruction auch das zweite Byte überspringen
								if ((op & 0b00001111) == JUMP_BACKWARD || (op & 0b00001111) == JUMP_FORWARD) program_counter++;
							}
						}
					}

					//	Unschön, aber nötig, da der Programmzähler am Ende der Hauptschleife wieder inkrementiert wird
					program_counter--;
				}
				else if (jump == JUMP_BACKWARD)
				{
					//	Springe frame_count frames rückwärts

					frame_count++;
					program_counter --;	//	Vor die aktuelle NEXT-Instruction springen

					unsigned char search = TRUE;
					while (search)
					{
						unsigned char op = pgm_read_byte(&(program_pointer[program_counter]));
						if ((op & OP_NEXT) == OP_NEXT)
						{
							frame_count--;

							if (frame_count == 0)
							{
								//	Ziel erreicht
								search = FALSE;

								//	Hinter das NEXT springen
								program_counter++;
								//	Bei zwei Byte langer NEXT-Instruction auch das zweite Byte überspringen
								if ((op & 0b00001111) == JUMP_BACKWARD || (op & 0b00001111) == JUMP_FORWARD) program_counter++;
							}
						}

						if (search)
						{
							if (program_counter > 0)
							{
								program_counter--;
							}
							else
							{
								//	Untere Programmgrenze erreicht
								search = FALSE;
							}
						}
					}
				}
			}

		}

		//	Programmzähler erhöhen, bzw. bei Erreichen des Programmendes wieder von vorn beginnen
		if (program_counter + 1 < program_length) program_counter++; else program_counter = 0;

	}

}


//	Initialisieren
void init()
{
	//	Ports vorbereiten
	DDRB =	0b11111111;	//	PB0-PB7: LED 1-8 (Kathoden)
	PORTB =	0b11111111;	//	HIGH

	DDRD =	0b1111000;	//	PD6: LED 9 (Kathode); PD5-PD3: A-C (Anoden)
	PORTD =	0b1000000;

	//	Timer-Interrupt "TIMER1" vorbereiten
	cli();

	set_bit(TIMSK, OCIE1A);
	set_bit(TCCR1B, WGM12);

	//	Animations-Geschwindigkeit
	OCR1AH = 0x01;
	OCR1AL = 0x00;

	clear_bit(TCCR1B, CS12);	//	Prescaler 64
	set_bit(TCCR1B, CS11);
	set_bit(TCCR1B, CS10);

	sei();
}


//	Interruptvektor von TIMER1
SIGNAL(SIG_OUTPUT_COMPARE1A)
{
	//	Pixel multiplexen
	for (unsigned char z = 0; z < 3; z++)
	{
		for (unsigned char y = 0; y < 3; y++)
		{
			for (unsigned char x = 0; x < 3; x++)
			{
				unsigned char n = z * 3 + x;

				//	LED an
				if (cube[x][y][z] == 1)
				{
					if (n < 8) clear_bit(PORTB, n); else clear_bit(PORTD, 6);
					set_bit(PORTD, y + 3);
				}
				//	ON-Time
				for (unsigned long i = 0; i < PIXEL_TON; i++) { asm volatile("nop"::); }

				//	LED aus
				if (cube[x][y][z] == 1)
				{
					clear_bit(PORTD, y + 3);
					if (n < 8) set_bit(PORTB, n); else set_bit(PORTD, 6);
				}
				//	OFF-Time
				for (unsigned long i = 0; i < PIXEL_TOFF; i++) { asm volatile("nop"::); }
			}
		}
	}
}
